#include "variables.h"

// Definimos de que tipo van a ser las variables
// especulativas
#ifdef data_float
  typedef float data_spec;
#endif
#ifdef data_int
  typedef int data_spec;
#endif
  
// upperlimit used in the following invocation
int upper_limit;

// Variables to hold squash statistics
//int spec_violations;
//int spec_squashes;
// Useful for vAxx
int squash_notifications;
int squashes_avoided;

// End of appcommon-part1.h
// **********************************************************************

data_spec shadow[wsize][shared_size];
data_spec maincopy[shared_size];
data_spec value;
int temp;


#ifdef logical 
  typedef enum { F = 0 , T = 1 } boolean;
  boolean gELV[shared_size];
#else
  char gELV[shared_size];
#endif
// **********************************************************************
// Beginning of appcommon-part2.h

// Array for storing MODULO indexes.
// This array will be filled whit data in specinit()
int modvector[max_upper_limit + 8];

// partial loop bounds
int lower_bound, upper_bound;

// wheel and pointers
// (Note: whell_ol is only used with conservative windows)
int wheel_ns, wheel_ms, wheel_ol;
int wheel[wsize];

// Useful for vAxx, unused by others
int improves_solution[wsize];

// spec access vectors
//char gELV[shared_size];
//char AV[shared_size][wsize];
//int IV[shared_size][wsize], IV_tail[wsize];
char AV[wsize][shared_size];
int IV[wsize][shared_size], IV_tail[wsize];

/**
 ** @author Alvaro
 ** @version ASversion data structures
 ** @var consumer_list[i][j] if value=1 then Thread i has consumed a data from thread j
 ** @var bubbles slots between wheel_ns and wheel_ms that must be assigned to a thread
*/
char consumer_list[wsize][wsize];
int bubbles;


/** @param endLoop flag to indicate when a loop must be stalled
**  0 keep going
**  1 stopping loop
**/
int endLoop;
/** @param endReturn flag to indicate when a function must be stalled
**  0 do not return
**  1 invoke return
**/
int endReturn;


// auxiliary variables for counters, id's, etc
//int specaux1, specaux2, specaux3;
//int tidaux;
//int index;
int linear;
//boolean flag;
char retflag;

int squashid;
int freedcell;

// thread id's
int tid;

// Vector with variable block size
// (only useful from speccode-v134)
int varblock[3][max_upper_limit+1];
int maxblock;

// New for v136: local, temporary IV_tail variable
int my_IV_tail;

// Number of threads to be considered for dynamic sheduling
// (only useful from speccode-v141)
int Ksched;
//#define Ksched threads
//#define Ksched 2*threads
//#define Ksched wsize
 
// speculative functions
void specstart(int iterations);
void specinit();
int specload(int index, int current, data_spec *value, data_spec *maincopy, int *my_IV_tail);
void specstore(int index, int current, data_spec value, int *my_IV_tail);
char threadend(int *current, int *nonSpeculative, data_spec *maincopy, int *my_IV_tail);
int commit(data_spec *maincopy);
void avclear_(void *start , int size);
void gelvclear_(void *start , int size);
void ivclear_(void *start , int size);
void dynscheduler(int chunk);
void specredmax(int index, int current, data_spec value, int *my_IV_tail);
void specredadd(int index, int current, data_spec value, int *my_IV_tail);
void cleanaccessv(int freedcell);
void specepilogue();
void squashThreads();
void breakEnd(int current,data_spec *maincopy, int my_IV_tail);
void setEndLoop();
int isNonSpeculative();
int getFirstBlock(int *current,int *nonSpeculative, int *my_IV_tail);


// End of appcommon-part2.h
// **********************************************************************
