/**
 * @author Alvaro Garcia Yaguez
 * @date 24th of January 2011
 * File to handle exceptions
**/
#include <omp.h>
#include <setjmp.h>
#include <signal.h>
#include "appcommon2.h"

/** @param sigjmp_buf
    maintain the returning points after handling a signal
**/
static sigjmp_buf jmpbuf[threads];

/** 
 * Macro to define functions to deal with the exceptions generated 
**/
#define newException(nameFunction)  \
	void nameFunction(int error)		\
	{											\
  		/*printf("TID: %d handling sinal %d\n",omp_get_thread_num(),nonSpeculative); 	\
                Deal with the exception by restarting threads*/					\
		/*if (isNonSpeculative()) */							\
		/*if (nonSpeculative == 1) 							\
		{										\
		  printf("Signal %d aborts the program\n",error);				\
		  abort(); 									\
		}	*/									\
  		/*printf("TID: %d Return\n",omp_get_thread_num()); 	\
                Returning to a safety checkpoint*/						\
		siglongjmp(jmpbuf[omp_get_thread_num()],1);				\
	}										


/** 
 * Macro to connect a signal to a concrete function
**/
#define setException(nameFunction, signalCaptured )	\
	struct sigaction act_##nameFunction_##signalCaptured;		\
	act_##nameFunction_##signalCaptured.sa_handler = nameFunction;					\
	sigemptyset(&act_##nameFunction_##signalCaptured.sa_mask);									\
	act_##nameFunction_##signalCaptured.sa_flags = 0;										\
	if (sigaction(signalCaptured,&act_##nameFunction_##signalCaptured,NULL ) < 0)								\
	{												\
		perror("Error setting up handler");						\
		exit(1);										\
	}												\

/** 
 * Returning point after raising an exception 
 * A new block of iterations will be assigned providing that
 * there are still work to execute
 * @var vector: speculative structurevector,bloque,ini,etiqueta)      \
 * @var bloque: 
 * @var ini: offset according to the initial
		 iteration for (i=100; i>1;i--) then ini=100
 * @var etiqueta: label's name for the goto instruction
**/
#define checkPoint(vector,bloque,ini,etiqueta)      \
        if ( sigsetjmp(jmpbuf[omp_get_thread_num()],1))                 \
        {                                                               \
		if (nonSpeculative == 1) 							\
		{										\
		  printf("Signal %d aborts the program\n");				\
		  abort(); 									\
		}										\
                /*printf("checkpoint1: tid = %d\n",omp_get_thread_num());*/\
		squashThreads(current);								\
                retflag = threadend( &current, &nonSpeculative, vector, &my_IV_tail);      \
                if ( retflag == JOBDONE ) goto etiqueta;                             \
                if ( retflag == JOBTODO )                                       \
                {                                                               \
                        bloque = varblock[0][current] + ini;                               \
                        varblock[2][current] = varblock[2][current] + 1;      \
                }                                                               \
        }                                                                       

