#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

/* Funtion to get the current time.  */
double gettime()
{
   struct timeval tv;
   gettimeofday(&tv, (void *)0);
   return (tv.tv_sec + 1.0e-6*tv.tv_usec);
}

/*******************************************/
/* User parameters set by the programmer:  */
/*******************************************/
// Array size 
#define MAX 4
// Number of iterations of the loop
#define NITER 6000


/*--------------------------------------------------------------------------*/

int main() {

// Global data structure
int array[MAX];
int array2[MAX];
	/* Local variables:*/
	struct prueba{
		//char campo_char;
		int campo_int;
		//short campo_short;
		//double campo_double;
		//float campo_float;
	};
	struct prueba p1 = {3};
	struct prueba p2 = {99999};
	struct prueba p3 = {11111};
	char aux_char = 'a';
	//int aux_int;
	//short aux_short;
	double aux_double = 3.435;
	//float aux_float;
	int aux, i, j;

	FILE *file;

	/* Open and read the file.  */
	if ((file = fopen("data.in", "r")) == NULL) {
		printf("Error opening the file\n ");
		exit(0);
	} else {
		j = fscanf(file, "%d", &aux);
		for (i = 0; i < MAX; i++) {
			array[i] = aux;
			j = fscanf(file, "%d", &aux);
		}
		fclose(file);
	}

	// Values of elements before processing:
	printf("ANTES:\n");
	printf("aux_char=%c,\n",aux_char);
	printf("aux_double=%f,\n",aux_double);
	printf("p1.campo_int=%d,\n",p1.campo_int);
	printf("p2.campo_int=%d,\n",p2.campo_int);
	printf("p3.campo_int=%d,\n",p3.campo_int);

	/* Start profiling.  */
	double seq_init = 0;
	double seq_end = 0;
	double seq_time = 0;
	seq_init = gettime();

	// The loop is not parallelizable because indexes of 
	// the array elements depends on the input values from a file
	for ( i = 0 ; i < NITER ; i++ ) {
		for ( j = 0 ; j < NITER ; j++ ) {
			if (i <= 1000)
				p1.campo_int = array[i%4] + j;
			else
				array2[i%4] = p1.campo_int;
			if (i > 2000)
				aux_char = i%20 + 48 + aux_char%48;
			else
				aux_char = i%20 + array[i%4]%10 + 48;
			if (i > 1500)
				aux_double = array[i%4]/(i+1) + aux_double;
			else
				array2[i%4] = (i*j) + (array2[(i+j)%4] +i*j)%1234545;
			if (i*j > 10000)
				p1 = p2;
			else
				p3 = p1;
		}
	}
	
	/* Stop profiling.  */
	seq_end = gettime();
	seq_time += seq_end - seq_init;

	/********************/
	/* Writing results  */
	/********************/
	// Values of elements before processing:
	printf("DESPUES:\n");
	printf("aux_char=%c,\n",aux_char);
	printf("aux_double=%f,\n",aux_double);
	printf("p1.campo_int=%d,\n",p1.campo_int);
	printf("p2.campo_int=%d,\n",p2.campo_int);
	printf("p3.campo_int=%d,\n",p3.campo_int);
	for (i=0;i<MAX;i++)
		printf("array2[%d]=%d,\n",i,array2[i]);
	
	/****************************/
	/* Printing execution times */
	/****************************/
	fprintf(stderr,"Execution time: %f seg. \n", seq_time);
	

	return 0;
}


