
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

//***********************************************************************
// speccode: OpenMP header file included
#include <omp.h>
//***********************************************************************
//***********************************************************************
// speccode: Main header file with all common variables
#include "specEngine.h"
//************************************************************************

/*******************************************/
/* User parameters set by the programmer:  */
/*******************************************/
// Array size 
#define MAX 4
// Number of iterations of the parallel loop
#define NITER 6000

/* Funtion to get the current time.  */
double gettime()
{
	 struct timeval tv;
	 gettimeofday(&tv, (void *)0);
	 return (tv.tv_sec + 1.0e-6*tv.tv_usec);
}


/*--------------------------------------------------------------------------*/

int main() {

// Global data structure
int array[MAX];
int array2[MAX];
		
	/* Local variables:*/
	struct prueba{
		//char campo_char;
		int campo_int;
		//short campo_short;
		//double campo_double;
		//float campo_float;
	};
	struct prueba p1 = {3};
	struct prueba p2 = {99999};
	struct prueba p3 = {11111};
	char aux_char = 'a';
	//int aux_int;
	//short aux_short;
	double aux_double = 3.435;
	//float aux_float;
	int aux, i, j;

	FILE *file;

	/* Open and read the file.  */
	if ((file = fopen("data.in", "r")) == NULL) {
		printf("Error opening the file\n ");
		exit(0);
	} else {
		j = fscanf(file, "%d", &aux);
		for (i = 0; i < MAX; i++) {
			array[i] = aux;
			j = fscanf(file, "%d", &aux);
		}
		fclose(file);
	}

	// Values of elements before processing:
	printf("ANTES:\n");
	printf("aux_char=%c,\n",aux_char);
	printf("aux_double=%f,\n",aux_double);
	printf("p1.campo_int=%d,\n",p1.campo_int);
	printf("p2.campo_int=%d,\n",p2.campo_int);
	printf("p3.campo_int=%d,\n",p3.campo_int);

	//***********************************************************************
	// speccode: OMP threading directive
	omp_set_num_threads(threads);
	// Initialize data structures needed to speculative parallelization
	specbegin(NITER);
	//***********************************************************************
	
	// speccode: Speculative loop
	int iteration, ini, int_value;
	char char_value;
	double double_value;
	int itera_parallel = 0;

	/************************************************************************/
	// speccode: Start profiling
	double spec_time=0;
	double spec_start, spec_stop;
	spec_start = gettime();
	/***********************************************************************/

#pragma omp parallel default(none)	\
	private(j, iteration, ini, current, tid, retflag,int_value,char_value,double_value) \
	shared(array, array2, p1, p2, p3, aux_char, aux_double, wheel_ns, wheel_ms, wheel, upper_limit, varblock) \
	reduction(+:itera_parallel)
{
#pragma omp for \
	schedule(static)
	
	for (tid = 0; tid <= threads - 1; tid++) {
 
		// ======================================
		// Diego, Fri Feb  1 11:03:39 CET 2013: todo esto es viejo. 
		// ini = 0;
		//	
		//if (getFirstBlock(&current, &nonSpeculative) == 0) {
		//    goto labelEndLoop_1;
		// }
		// iteration = varblock[0][current] + ini;
		// varblock[2][current] = varblock[2][current] + 1;
		// ======================================
		
		// Diego, Fri Feb  1 11:03:39 CET 2013: todo esto es nuevo. 
		// La variable ini indica la primera iteración a ejecutarse. En
		// esta aplicación es la cero.
		ini = 0;
		current = tid;
		iteration = varblock[0][current]+ini;
		// If there is not work to this thread, go out.
		if (iteration > upper_limit - 1)
			goto labelSquash_1;
		// Increment the number of attempts for this iteration.
		varblock[2][current] = varblock[2][current]+1;
		
		// Diego, Fri Feb  1 11:03:39 CET 2013: fin de los cambios.
		// ======================================
 
labelStartIteration_1: 
#ifdef MEASURE_COUNTERS
		itera_parallel++;
#endif
		//  For loop body code
		//for ( j = 0 ; j < NITER ; j++ ) {
			if (iteration <= 1000){
				//p1.campo_int = array[i%4] + j;
				//int_value = array[iteration%4] + j;
				int_value = array[iteration%4];
				specstore_pointer((void *) &(p1.campo_int), sizeof (p1.campo_int), current, (void *) &int_value);
			} else {
				//array2[i%4] = p1.campo_int;
				if (specload_pointer((void *) &(p1.campo_int), sizeof (p1.campo_int), current, (void *) &int_value) == -1)
					earlySquash(1);
				specstore_pointer((void *) &(array2[iteration%4]), sizeof (array2[iteration%4]), current, (void *) &int_value);
			}
			if (iteration > 2000){
				//aux_char = i%20 + 48 + aux_char%48;
				if (specload_pointer((void *) &(aux_char), sizeof (aux_char), current, (void *) &char_value) == -1)
					earlySquash(1);
				char_value = iteration%20 + 48 + char_value%48;
				specstore_pointer((void *) &(aux_char), sizeof (aux_char), current, (void *) &char_value);
			} else {
				//aux_char = i%20 + array[i%4]%10 + 48;
				char_value = iteration%20 + array[iteration%4]%10 + 48;
				specstore_pointer((void *) &(aux_char), sizeof (aux_char), current, (void *) &char_value);
			} if (iteration > 1500) {
				//aux_double = array[i%4]/(i+1) + aux_double;
				/*if (specload_pointer((void *) &(aux_double), sizeof (aux_double), current, (void *) &double_value) == -1)
					earlySquash(1);
				double_value = array[iteration%4]/(iteration+1) + double_value;
				specstore_pointer((void *) &(aux_double), sizeof (aux_double), current, (void *) &double_value);*/
				double_value = (double) array[iteration%4]/(iteration+1);
				//printf("iteration %d,aux_double = %lf\n",iteration,aux_double);
				specredadd((void *) &aux_double, sizeof(aux_double), current, (void *) &double_value);
			} else {
				//array2[iteration%4] = (int) (aux_double / iteration*j) + (array2[(iteration+j)%4] +iteration*j)%1234545;
				if (specload_pointer((void *) &(aux_double), sizeof (aux_double), current, (void *) &double_value) == -1)
					earlySquash(1);
				//if (specload_pointer((void *) &(array2[(iteration+j)%4]), sizeof (array2[(iteration+j)%4]), current, (void *) &int_value) == -1)
				if (specload_pointer((void *) &(array2[(iteration)%4]), sizeof (array2[(iteration)%4]), current, (void *) &int_value) == -1)
					earlySquash(1);
				//int_value = (int) (double_value / iteration*j) + (int_value + iteration*j)%1234545;
				int_value = (int) (double_value / iteration) + (int_value + iteration)%1234545;
				specstore_pointer((void *) &(array2[iteration%4]), sizeof (array2[iteration%4]), current, (void *) &int_value);
			//} if (iteration*j > 10000) {
			}
	                if (iteration > 10000) {
				//p1 = p2;
				specstore_pointer((void *) &(p1), sizeof (p1), current, (void *) &p2);
			} else {
				//p3 = p1;
				if (specload_pointer((void *) &(p1), sizeof (p1), current, (void *) &p3) == -1)
					earlySquash(1);
			}
		//}

		/***********************************************************************/


labelEndIteration_1:
		if ((iteration != varblock[1][current] + ini) && (iteration < NITER - 1)) {
			iteration = iteration + 1;
			goto labelStartIteration_1;
		}
		
		/* Thread done, perform the commit */
labelSquash_1:

		// ======================================
		// Diego, Fri Feb  1 11:03:39 CET 2013: todo esto es viejo. 
								// threadend_pointer sólo tiene un parámetro de entrada:
		// retflag = threadend_pointer(&current, &nonSpeculative);
		retflag = threadend_pointer(&current);
		// Diego: fin de cambios.
		// ======================================
		
		/* End if job done */
		if (retflag == JOBDONE) goto labelEndLoop_1;
		if (retflag == JOBTODO) {
		
			/*  Set loop variable */
			iteration = varblock[0][current] + ini;
			varblock[2][current] = varblock[2][current] + 1;
			goto labelStartIteration_1;
		}

labelEndLoop_1:
		; /*freeWheel(current);*/
	
	} /*End of the FOR loop*/

} // #pragma omp parallel

	/************************************************************************/
	// speccode: Stop measuring time
	spec_stop = gettime();
	spec_time += spec_stop - spec_start;
	/************************************************************************/

//	speccode: free speculation structures
	specend();

#ifdef TIME_SPECLOAD
 printSpecloadTime();
#endif
#ifdef TIME_SPECSTORE
 printSpecstoreTime();
#endif

#ifdef MEASURE_COUNTERS
 specepilogue();
 printAccesses();
#endif

	/********************/
	/* Writing results  */
	/********************/
	// Values of elements before processing:
	printf("DESPUES:\n");
	printf("aux_char=%c,\n",aux_char);
	printf("aux_double=%f,\n",aux_double);
	printf("p1.campo_int=%d,\n",p1.campo_int);
	printf("p2.campo_int=%d,\n",p2.campo_int);
	printf("p3.campo_int=%d,\n",p3.campo_int);
	for (i=0;i<MAX;i++)
		printf("array2[%d]=%d,\n",i,array2[i]);
	
#ifdef MEASURE_COUNTERS
	printf("Iterations done in parallel: %d\n", itera_parallel);
#endif

	fprintf(stderr,"Execution time: %f seg. \n", spec_time);
	return 0;
}
