#!/bin/bash

APP=incr-2d-seq

INPUTSET=$1

make clean
make

# Generate "script"
echo "#! /bin/bash" > script
echo "#$ -cwd" >> script
echo "#$ -pe threads 1" >> script
echo "/usr/bin/time -p ./incr-2d $INPUTSET" >> script

# Submit "script"
rm -rf script.*
RUN=`qsub script | cut -d " " -f 3`

control_c()
# run if user hits control-c
{
  echo -en "\n*** Ouch! Exiting ***\n"
  qdel $RUN
  exit $?
}
       
# trap keyboard interrupt (control-c)
trap control_c SIGINT



# Waiting for the script.o* file to be created
echo "Experiment $RUN queued."
while ! test -e script.o*
do
   sleep 1 ;
done

despues=$(date --date='+1 min' +%s)
# Waiting for the script.o* file to be created
echo "Experiment $RUN running."
qstat | grep $RUN > tt
while test -s tt
do
   sleep 1 ;
   qstat | grep $RUN > tt
   ahora=$(date +%s)
   if [ ${ahora} -ge ${despues} ]
   then
     echo -en "\n*** Ouch! Exiting *** Time exceeded: Experiment carried more than 1 minute\n"
     qdel $RUN
     exit $?
   fi
done
rm tt

# Compare results
echo "Experiment $RUN finished."
#if ! diff script.o* ../01*/incr-2d.out 
#then
#   echo "$0: Results differ." 
#exit -1
#fi

APP2=`echo $INPUTSET | awk -F / '{print $(NF)}'`
FILENAME=$APP-$APP2

mv script.e* Results/$FILENAME.txt
mv script.o* Results/o$FILENAME.txt

