#!/bin/bash

APP=mec-2d-seq

INPUTSET=$1

make clean
make

# Generate "script"
echo "#! /bin/bash" > script
echo "#$ -cwd" >> script
echo "#$ -pe threads 1" >> script
echo "/usr/bin/time -p ./mec-2d $INPUTSET" >> script

# Submit "script"
rm -rf script.*
RUN=`qsub script | cut -d " " -f 3`

# Waiting for the script.o* file to be created
echo "Experiment $RUN queued."
while ! test -e script.o*
do
   sleep 1 ;
done

# Waiting for the script.o* file to be created
echo "Experiment $RUN running."
qstat | grep $RUN > tt
while test -s tt
do
   sleep 1 ;
   qstat | grep $RUN > tt
done
rm tt

# Compare results
echo "Experiment $RUN finished."
if ! diff script.o* ../01*/mec-2d.out 
then
   echo "$0: Results differ." 
#exit -1
fi

APP2=`echo $INPUTSET | awk -F / '{print $(NF)}'`
FILENAME=$APP-$APP2

mv script.e* Results/$FILENAME.txt
mv script.o* Results/o$FILENAME.txt

