#!/bin/bash

if test $# != 1
then
   echo "$0: format: $0 threads"
   exit -1
fi

APP=mec-2d
THREADS=$1

make clean
make threads=$THREADS maxiter=2688911 blocksize=1800 maxpointer=10 mask=7
#make threads=$THREADS maxiter=2688911 blocksize=1 maxpointer=10 mask=7

#DYN_TENT
#make maxiter=2688911 blocksize=-6 maxpointer=10 mask=7 threads=$THREADS

#ADA_TENT
#make maxiter=10000000 blocksize=-7 maxpointer=10 mask=7 threads=$THREADS
#make maxiter=2688911 blocksize=-7 maxpointer=10 mask=7 threads=$THREADS

./$APP > sal.out 2> sal.err

# Compare results
echo "Experiment $RUN finished."
if ! diff sal.out ../01*/Results/*.out 
then
   echo "$0: Results differ." 
#exit -1
fi

if [ $THREADS -lt 10 ]
then 
   FILENAME=$APP-0$THREADS
else
   FILENAME=$APP-$THREADS
fi 

mv sal.err Results/$FILENAME.txt
mv sal.out Results/o$FILENAME.txt
