

/************************************************************************/
// Constants 
//
// N: total number of points (min. 3)
   //#define N 100000
   #define N 1000000

// MAX_ANCHORS: total number of anchors (min. 1)
  // For N=1M, MAX_ANCHORS=850
  // For N=5M, MAX_ANCHORS=1990
  // #define MAX_ANCHORS 1990
  #define MAX_ANCHORS 5000
  //#define MAX_ANCHORS 850

// MAX_TRIANGLES: Maximum number of triangles.
// The number of triangles on the final triangulation is well known
// (2*N-2, N = #points). We need one additional triangle to start.
// We use 2*N+10, just in case.
   #define MAX_TRIANGLES 2*N+10

// NULL element
   #define NULO -1

/************************************************************************/
// Data structures
//
// triangles: Table with triangles
// We also use the first element of the last MAX_ANCHORS rows of "triangles" to hold
// the indices of the triangles that contain the MAX_ANCHORS anchors.
   int triangles[MAX_TRIANGLES+MAX_ANCHORS][6];
   //int ** triangles;

// Indexes for each column of "triangles"
   #define p0 0
   #define p1 1
   #define p2 2
   #define t0 3
   #define t1 4
   #define t2 5
   #define anchor 0
   #define azone MAX_TRIANGLES
// In this way, the triangle that holds the first anchor will
// be triangles[azone][anchor]
//
// **********************************************************************/
// points: Floating-point matrix that holds the points.
// NOTE: Last three elements of "points" will hold the bounds.
   float points[N+3][2];
   //float ** points;

// Indexes for each column of the "points" table.
   #define x 0
   #define y 1 

// Indexes for the three bounds
   #define bound0 N
   #define bound1 N+1
   #define bound2 N+2

/************************************************************************/
// nt: number of triangles so far
   int nt;

   double dt_crc;

/************************************************************************/
// Functions
   void bounding_triangle();
   float signed_area(int a, int b, int c);
   int inside_triangle2(int p, int a, int b, int c);
   char insidecirc_test(int pp1, int pp2, int pp3, int pp4);
   void legalize_edge(int tt1, int ins_anchors);
   void revisa(int i, int pos);
   void write_dt();
   void count_dt();
   void iterative_write(int tr);
   void iterative_count(int tr);

/************************************************************************/
