/* Number of threads. 
* The number of threads are set as a parameter of the compiler
* with '-D numthreads=constant' */

//#ifdef numthreads
#if numthreads > 0
	#define threads numthreads
#else
	#error Number of threads are not defined
	//#define threads 1
#endif

/** @param wsize wheel size to execute iteration blocks
  */
#define wsize threads*2

/** @param blk block size
 */
//#define blk 3
#if blocksize != 0
	#define blk blocksize
#else
	#error Block size can not be 0
#endif


/* Parameters that depends on the number of iterations of the loop to parallelize  */
#if maxiter > 0
	#define max_upper_limit maxiter
#else
	#error Number of iterations are not defined
#endif

// Initial capacity reserved to pointers in a matrix
//#define MAX_POINTER 100
#if maxpointer > 0
	#define MAX_POINTER maxpointer
#else
	#error The initial capacity reserved to pointers in a matrix is not defined
#endif

// Number of rows that will contain auxiliary variables
//#define MASK 2^n-1 
#if mask > 0
	#define MASK mask
#else
	#error The size of the rows of auxiliary matrices is not defined
#endif
