
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

/*******************************************/
/* User parameters set by the programmer:  */
/*******************************************/
#define NITER 1000000

/* Funtion to get the current time.  */
double gettime()
{
	 struct timeval tv;
	 gettimeofday(&tv, (void *)0);
	 return (tv.tv_sec + 1.0e-6*tv.tv_usec);
}

/*--------------------------------------------------------------------------*/

int main() {

	// speccode: Speculative loop
	int iteration;
	double value;

	double sumatorio = 3.123124;

	/************************************************************************/
	// speccode: Start profiling
	double spec_time=0;
	double spec_start, spec_stop;
	spec_start = gettime();
	/***********************************************************************/

	for (iteration=0; iteration < NITER; iteration++) {
		value = (iteration % 2) + 0.0003*iteration;
		sumatorio = sumatorio + value;
		if (iteration%10000 == 9999)
			                printf("sum=%lf,it=%d\n",sumatorio,iteration);

	}

	/************************************************************************/
	// speccode: Stop measuring time
	spec_stop = gettime();
	spec_time += spec_stop - spec_start;
	/************************************************************************/

	/****************************/
	/* Printing execution times */
	/****************************/
	printf("Sumatorio = %lf.\n", sumatorio);
	fprintf(stderr,"Speculative time: %lf seconds.\n", spec_time);


#ifdef TIME_SPECLOAD
 printSpecloadTime();
#endif
#ifdef TIME_SPECSTORE
 printSpecstoreTime();
#endif

#ifdef MEASURE_COUNTERS
 specepilogue();
 printAccesses();
#endif

	return 0;
}
