/*  */

#include <stdio.h>
#include "specEngine.h"

/* For debugging purposes.  */
#include <time.h>


/* Speculative Engine functions. Only for plugin test purposes.  */
void specstore_pointer1 (unsigned char *variable, int size, int current, unsigned char *value)
{
	int tid = omp_get_thread_num();
	printf("[%d] spectore_pointer(?,?,%d,?) writing into speculative variable = %d\n", tid, current, *value);
	
	*variable = *value;
}

int specload_pointer1 (unsigned char *variable, int size, int current, unsigned char* value)
{
	int tid = omp_get_thread_num();
	printf("[%d] specload_pointer(?,?,%d,?) reading from speculative variable = %d.\n", tid, current, *variable);

	*value = *variable;

	//sleep(2);
	return 1;
}

void early_Squash (int i)
{
	int tid = omp_get_thread_num();
	printf("[%d] Early squashing\n", tid);
}

void speculative_start (int nIt)
{	
	printf("specstart inserted with argument: %d\n", nIt);
}

void speculative_init ()
{
	int i,j = 0;
	
	printf("specinit inserted in the beginning of the program.\n");
	
	for (i=0; i<3; i++)
		for (j=0; j<1000; j++)
		{
			varblock[i][j] = 17;
		}
}

int getFirstBlock1 (int *current, int *nonSpeculative)
{
	int tid = omp_get_thread_num();
	
	printf("[%d] getFirstBlock1() executed with arguments current = %d, nonSpeculative = %d \n", 
					tid, *current, *nonSpeculative);
	*current = 333;
	//*nonSpeculative = 6;
	return 1;
}

void freeWheel1 (int current)
{
	int tid = omp_get_thread_num();
	printf ("[%d] freeWheel1() executed with arguments current = %d\n", tid, current);
	//current = 1;
}

int threadend_pointer1 (int *current, int *nonSpeculative) 
{
	int tid = omp_get_thread_num();
	
	printf("[%d] threadend_pointer1() executed with arguments current = %d, nonSpeculative = %d\n",
						tid, *current, *nonSpeculative);
	//*current = 1;
	//*nonSpeculative = 3;
	return 0;	// 0:JOBDONE; 1:JOBTODO
}
