#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

/* Funtion to get the current time.  */
double gettime()
{
   struct timeval tv;
   gettimeofday(&tv, (void *)0);
   return (tv.tv_sec + 1.0e-6*tv.tv_usec);
}

/*******************************************/
/* User parameters set by the programmer:  */
/*******************************************/
// Array size 
#define MAX 100
// Number of iterations of the loop
#define NITER 10000
//#define NITER 1

// Global data structure
int a = 0;

/*--------------------------------------------------------------------------*/

int main() {

	/* Local variables:
	* 	i and j represent the number of iteration
	*		Q represents an the array index
	*/
	int P, Q, aux, i, j;
	FILE *file;
	int pre_sum = 0;
	int sum = 0;
	
	/* Start profiling.  */
	double seq_init = 0;
	double seq_end = 0;
	double seq_time = 0;
	seq_init = gettime();
	
	for ( i = 0; i < NITER; i++ )
	{
	// The loop is not parallelizable because indexes of 
	// the array elements depends on the input values from a file
#ifndef SEQUENTIAL
	specstart (i-1);
#endif	
	#pragma omp parallel for default(none) \
		private(Q,j,aux) \
		shared(i) \
		speculative(a)
		for ( j = 0 ; j < (i-1) ; j++ ) {
	
			Q = j % (MAX) + 1;
			aux = Q - 1 + a;

			Q = (4 * aux) % (MAX) + 1;
			a = Q;
		}
	}
	/* Stop profiling.  */
	seq_end = gettime();
	seq_time += seq_end - seq_init;

	/********************/
	/* Writing results  */
	/********************/
	printf("Exit value of a = %d\n", a);
	
	/****************************/
	/* Printing execution times */
	/****************************/
	fprintf(stderr, "Execution time: %f seg. \n", seq_time);
	
	return 0;
}


