/**
 * @author Alvaro Garcia Yaguez
 * @date 1st of March 2011
 * This macro should be used inside a speculative loop
 * instead of continue();
**/
#define continueSpecEngine(IDLOOP) 								\
	goto labelEndIteration_##IDLOOP;								

/** 
 * @author Alvaro Garcia Yaguez
 * @date 17th of March 2011
 * Finishing the loop because of a break instruction only if it is executed by
 * a no speculative thread. Otherwise, the thread is squashed with its successors
**/
#define breakSpecEngine(IDLOOP)								\
        /*if (isNonSpeculative()) */                                                        \
        if (nonSpeculative == 1)                                                         \
	{										\
	  breakEnd(current,(int *) vector, my_IV_tail);					\
	  /*setEndLoop();								\
	  squashSuccessors(current+1);							\
	  threadend( &current,(int *) vector, &my_IV_tail);				*/\
	  goto labelEndLoop_##IDLOOP; 									\
	}										\
	else										\
	{										\
	  squashThreads(current);                                                       \
	}	

/** 
 * @author Alvaro Garcia Yaguez
 * @date 18th of March 2011
 * @arg state returned value by the exit instruction
 * Finishing the program because of a exit instruction only if it is executed by
 * a no speculative thread. Otherwise, the thread is squashed with its successors
**/
#define exitSpecEngine(state)								\
        /*if (isNonSpeculative()) */                                                        \
        if (nonSpeculative == 1)                                                         \
	{										\
	  breakEnd(current,(int *) vector, my_IV_tail);					\
	  /*sumatorio = 0;			\
  	   Just to check the example results
          for( i = 0; i < MAX; i++)		\
          {					\
           sumatorio = sumatorio + vector[i];	\
          }					\
          printf("%d\n",sumatorio);		*/\
	  exit(state);									\
	}										\
	else										\
	{										\
	  squashThreads(current);                                                       \
	}	

/** 
 * @author Alvaro Garcia Yaguez
 * @date 21th of March 2011
 * Finishing the loop because of a return instruction only if it is executed by
 * a no speculative thread. Otherwise, the thread is squashed with its successors
 * @arg IDLOOP loop identifier
**/
#define returnSpecEngine(vector,IDLOOP)								\
        /*if (isNonSpeculative()) */                                                        \
        if (nonSpeculative == 1)                                                         \
	{										\
	  returnEnd(current, vector, my_IV_tail);					\
	  /*setEndLoop();								\
	  squashSuccessors(current+1);							\
	  threadend( &current,(int *) vector, &my_IV_tail);				*/\
	  goto labelEndLoop_##IDLOOP; 									\
	}										\
	else										\
	{										\
	  squashThreads(current);                                                       \
	}	

/** 
 * @author Alvaro Garcia Yaguez
 * @date 21th of March 2011
 * This macro must be called below the end of a speculative loop inside a function.
 * This macro enables to know if a return
 * instruction has been invoked by the no speculative thread. As OpenMP do not permit to
 * invoke a return instruction inside a loop, in this way the return is invoked outside
 * the loop.
**/
#define testReturnSpecEngine()								\
        if (endReturn)		                                                        \
	  return;

/** 
 * @author Alvaro Garcia Yaguez
 * @date 1st of March 2011
 * @arg iteration index of the iteration is being excuted inside the speculative loop
 * @arg ini initial index of the loop 
 * @arg IDLOOP loop identifier
 * Assigning the first block each thread
 * According to flag exceptions checkPoint is enabled or disabled
**/
#ifdef exceptions
#define initLoopSpecEngine(vector, iteration,ini,IDLOOP)			\
    for ( tid = 0 ; tid <= threads-1 ; tid++ )						\
    {											\
      /*if ( tid == 0 )									\
        nonSpeculative = 1;								\
      current = tid;									\
      my_IV_tail = 0;									\
      iteration = varblock[0][current]+ini;						\
      varblock[2][current] = varblock[2][current]+1;*/					\
      if ( getFirstBlock(&current, &nonSpeculative, &my_IV_tail ) == 0)			\
      {											\
        /*printf("NO TIENES TRABAJO %d\n",omp_get_thread_num());*/			\
	goto labelEndLoop_##IDLOOP;/*linea 181*/							\
      }											\
      iteration = varblock[0][current]+ini;						\
      varblock[2][current] = varblock[2][current]+1;					\
      checkPoint(vector, iteration, ini, labelEndLoop_##IDLOOP);			\
labelStartIteration_##IDLOOP:								
#endif
#ifndef exceptions
#define initLoopSpecEngine(vector, iteration,ini,IDLOOP)			\
    for ( tid = 0 ; tid <= threads-1 ; tid++ )						\
    {											\
      /*printf("INI %d\n",omp_get_thread_num());*/				 	\
      /*if ( tid == 0 )									\
        nonSpeculative = 1;								\
      current = tid;									\
      my_IV_tail = 0;*/									\
      if ( getFirstBlock(&current, &nonSpeculative, &my_IV_tail ) == 0)			\
      {											\
        /*printf("NO TIENES TRABAJO %d \n",omp_get_thread_num());*/			\
	goto labelEndLoop_##IDLOOP;							\
      }											\
      iteration = varblock[0][current]+ini;						\
      varblock[2][current] = varblock[2][current]+1;					\
      /*if ( iteration >= nIterations)							\
	goto labelEndLoop_##IDLOOP; 							*/\
labelStartIteration_##IDLOOP:		/*printf("ENDLOOP\n");*/						
#endif


/** 
 * @author Alvaro Garcia Yaguez
 * @date 1st of March 2011
 * @arg iteration index of the iteration is being excuted inside the speculative loop
 * @arg nIterations total number of iterations in the loop
 * @arg ini initial index of the loop 
 * @arg IDLOOP loop identifier
 * Returning point after ending an iteration
 * A new block of iterations will be assigned providing that
 * there are still work to execute
**/
#define endLoopSpecEngine(vector, iteration, nIterations, ini, IDLOOP)  \
	/**********************************************************************		\
	// speccode: end of thread and commit						\
	//           First check if block of iterations is done **************/		\
	if (endLoop || endReturn) 							\
        {										\
	  freeWheel(current);								\
          goto labelEndLoop_##IDLOOP;/*linea 181*/							\
        }										\
        labelEndIteration_##IDLOOP:							\
     	if ( (iteration != varblock[1][current]+ini) && (iteration < nIterations-1) )	\
	{			 							\
		iteration = iteration + 1;						\
                /*printf("%d. iteration %d, varblock[1][current]+ini %d, nIterations-1 %d\n",omp_get_thread_num(),iteration, varblock[1][current]+ini,nIterations);*/\
		goto labelStartIteration_##IDLOOP;/*linea 183*/					\
	}										\
	/* Thread done, perform the commit */						\
	labelSquash_##IDLOOP:								\
		retflag = threadend( &current, &nonSpeculative, vector, &my_IV_tail);		\
	/* End if job done */								\
	if ( retflag == JOBDONE ) goto labelEndLoop_##IDLOOP;/*linea 181*/				\
	if ( retflag == JOBTODO )							\
	{										\
	/*  Set loop variable */							\
		iteration = varblock[0][current] + ini ;				\
		varblock[2][current] = varblock[2][current] + 1;			\
                /*printf("tid %d ns %d, ms %d iteration %d totalIT %d current %d estadoWheel %d\n",omp_get_thread_num(),wheel_ns,wheel_ms,iteration,nIterations,current,wheel[current]);*/\
		goto labelStartIteration_##IDLOOP;					\
	}										\
	labelEndLoop_##IDLOOP: ; /*freeWheel(current);*/					\
	} /*End for initLoop()*/							\
    //} //End pragma omp


/** 
 * @author Alvaro Garcia Yaguez
 * @date 3rd of April 2011
 * @arg IDLOOP loop identifier
 * Going to the end of the loop to call threadend function
**/
#define earlySquash(IDLOOP)  \
        {\
        /*printf("SQUASH\n");*/\
	goto labelSquash_##IDLOOP;\
	}
